/*
 * Simulator of MCS51 (uccl.h)
 *
 * Copyright (C) 1999,99 Drotos Daniel, Talker Bt.
 * 
 * To contact author send email to drdani@mazsola.iit.uni-miskolc.hu
 *
 */

/* This file is part of MCS51 simulator: s51.

S51 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

S51 is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with S51; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA. */
/*@1@*/

#ifndef UCCL_HEADER
#define UCCL_HEADER

#include "stypes.h"
#include "pobjcl.h"
#include "hwcl.h"
#include "memcl.h"


/* Abstract microcontroller */

class cl_uc: public cl_base
{
public:
  class cl_list *mem;
  class cl_list *hws;

public:
  cl_uc(void);
  ~cl_uc(void);
  virtual int init(void);

  virtual int mk_rom(void);
  virtual int mk_xram(void);
  virtual int mk_iram(void);
  virtual int mk_sfr(void);
  virtual int mk_hw(void);

  virtual ulong read_mem(enum mem_class type, long addr);
  virtual void write_mem(enum mem_class type, long addr, ulong val);

  virtual void register_hw_read(enum mem_class, long addr, class cl_hw *hw);
  virtual void register_hw_write(enum mem_class, long addr, class cl_hw *hw);
};


#endif

/* End of uccl.h */
